/* application-startup-manager.c generated by valac 0.44.7, the Vala compiler
 * generated from application-startup-manager.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
/*
 * Manages desktop files in the autostart.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define APPLICATION_TYPE_STARTUP_MANAGER (application_startup_manager_get_type ())
#define APPLICATION_STARTUP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_STARTUP_MANAGER, ApplicationStartupManager))
#define APPLICATION_STARTUP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_STARTUP_MANAGER, ApplicationStartupManagerClass))
#define APPLICATION_IS_STARTUP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_STARTUP_MANAGER))
#define APPLICATION_IS_STARTUP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_STARTUP_MANAGER))
#define APPLICATION_STARTUP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_STARTUP_MANAGER, ApplicationStartupManagerClass))

typedef struct _ApplicationStartupManager ApplicationStartupManager;
typedef struct _ApplicationStartupManagerClass ApplicationStartupManagerClass;
typedef struct _ApplicationStartupManagerPrivate ApplicationStartupManagerPrivate;

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
enum  {
	APPLICATION_STARTUP_MANAGER_0_PROPERTY,
	APPLICATION_STARTUP_MANAGER_NUM_PROPERTIES
};
static GParamSpec* application_startup_manager_properties[APPLICATION_STARTUP_MANAGER_NUM_PROPERTIES];
#define _configuration_unref0(var) ((var == NULL) ? NULL : (var = (configuration_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ApplicationStartupManager {
	GObject parent_instance;
	ApplicationStartupManagerPrivate * priv;
};

struct _ApplicationStartupManagerClass {
	GObjectClass parent_class;
};

struct _ApplicationStartupManagerPrivate {
	Configuration* config;
	GFile* installed_file;
	GFile* startup_file;
};

static gint ApplicationStartupManager_private_offset;
static gpointer application_startup_manager_parent_class = NULL;

GType application_startup_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ApplicationStartupManager, g_object_unref)
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Configuration, configuration_unref)
#define APPLICATION_STARTUP_MANAGER_AUTOSTART_FOLDER "autostart"
#define APPLICATION_STARTUP_MANAGER_AUTOSTART_DESKTOP_FILE "geary-autostart.desktop"
ApplicationStartupManager* application_startup_manager_new (Configuration* config,
                                                            GFile* desktop_dir);
ApplicationStartupManager* application_startup_manager_construct (GType object_type,
                                                                  Configuration* config,
                                                                  GFile* desktop_dir);
GSettings* configuration_get_settings (Configuration* self);
#define CONFIGURATION_STARTUP_NOTIFICATIONS_KEY "startup-notifications"
static void application_startup_manager_on_startup_notification_change (ApplicationStartupManager* self);
static void _application_startup_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender,
                                                                                     const gchar* key,
                                                                                     gpointer self);
GFile* application_startup_manager_get_installed_desktop_file (ApplicationStartupManager* self);
void application_startup_manager_install_startup_file (ApplicationStartupManager* self,
                                                       GError** error);
void application_startup_manager_delete_startup_file (ApplicationStartupManager* self,
                                                      GError** error);
void application_startup_manager_sync_with_config (ApplicationStartupManager* self);
void configuration_set_startup_notifications (Configuration* self,
                                              gboolean value);
gboolean configuration_get_startup_notifications (Configuration* self);
static void application_startup_manager_finalize (GObject * obj);

static inline gpointer
application_startup_manager_get_instance_private (ApplicationStartupManager* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationStartupManager_private_offset);
}

static gpointer
_configuration_ref0 (gpointer self)
{
	return self ? configuration_ref (self) : NULL;
}

static void
_application_startup_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender,
                                                                                const gchar* key,
                                                                                gpointer self)
{
	application_startup_manager_on_startup_notification_change ((ApplicationStartupManager*) self);
}

ApplicationStartupManager*
application_startup_manager_construct (GType object_type,
                                       Configuration* config,
                                       GFile* desktop_dir)
{
	ApplicationStartupManager * self = NULL;
	Configuration* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	gchar* _tmp10_;
	g_return_val_if_fail (IS_CONFIGURATION (config), NULL);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (desktop_dir, g_file_get_type ()), NULL);
	self = (ApplicationStartupManager*) g_object_new (object_type, NULL);
	_tmp0_ = _configuration_ref0 (config);
	_configuration_unref0 (self->priv->config);
	self->priv->config = _tmp0_;
	_tmp1_ = g_file_get_child (desktop_dir, APPLICATION_STARTUP_MANAGER_AUTOSTART_DESKTOP_FILE);
	_g_object_unref0 (self->priv->installed_file);
	self->priv->installed_file = _tmp1_;
	_tmp2_ = g_get_user_config_dir ();
	_tmp3_ = g_file_new_for_path (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_get_child (_tmp4_, APPLICATION_STARTUP_MANAGER_AUTOSTART_FOLDER);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_file_get_child (_tmp6_, APPLICATION_STARTUP_MANAGER_AUTOSTART_DESKTOP_FILE);
	_g_object_unref0 (self->priv->startup_file);
	self->priv->startup_file = _tmp7_;
	_g_object_unref0 (_tmp6_);
	_g_object_unref0 (_tmp4_);
	_tmp8_ = configuration_get_settings (config);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat ("changed::", CONFIGURATION_STARTUP_NOTIFICATIONS_KEY, NULL);
	g_signal_connect_object (_tmp9_, _tmp10_, (GCallback) _application_startup_manager_on_startup_notification_change_g_settings_changed, self, 0);
	_g_free0 (_tmp10_);
	return self;
}

ApplicationStartupManager*
application_startup_manager_new (Configuration* config,
                                 GFile* desktop_dir)
{
	return application_startup_manager_construct (APPLICATION_TYPE_STARTUP_MANAGER, config, desktop_dir);
}

/**
     * Returns the system-wide autostart desktop file if it exists.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GFile*
application_startup_manager_get_installed_desktop_file (ApplicationStartupManager* self)
{
	GFile* result = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp3_;
	g_return_val_if_fail (APPLICATION_IS_STARTUP_MANAGER (self), NULL);
	_tmp1_ = self->priv->installed_file;
	if (g_file_query_exists (_tmp1_, NULL)) {
		GFile* _tmp2_;
		_tmp2_ = self->priv->installed_file;
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = NULL;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	result = _tmp3_;
	return result;
}

/**
     * Copies the autostart desktop file to the autostart directory.
     */
void
application_startup_manager_install_startup_file (ApplicationStartupManager* self,
                                                  GError** error)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (APPLICATION_IS_STARTUP_MANAGER (self));
	_tmp0_ = self->priv->startup_file;
	if (!g_file_query_exists (_tmp0_, NULL)) {
		GFile* autostart_dir = NULL;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* autostart = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		_tmp1_ = self->priv->startup_file;
		_tmp2_ = g_file_get_parent (_tmp1_);
		autostart_dir = _tmp2_;
		_tmp3_ = autostart_dir;
		if (!g_file_query_exists (_tmp3_, NULL)) {
			GFile* _tmp4_;
			_tmp4_ = autostart_dir;
			g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (autostart_dir);
				return;
			}
		}
		_tmp5_ = application_startup_manager_get_installed_desktop_file (self);
		autostart = _tmp5_;
		_tmp6_ = autostart;
		if (_tmp6_ == NULL) {
			g_warning ("application-startup-manager.vala:52: Autostart file is not installed!");
		} else {
			GFile* _tmp7_;
			GFile* _tmp8_;
			_tmp7_ = autostart;
			_tmp8_ = self->priv->startup_file;
			g_file_copy (_tmp7_, _tmp8_, 0, NULL, NULL, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (autostart);
				_g_object_unref0 (autostart_dir);
				return;
			}
		}
		_g_object_unref0 (autostart);
		_g_object_unref0 (autostart_dir);
	}
}

/**
     * Deletes the desktop file from autostart directory.
     */
void
application_startup_manager_delete_startup_file (ApplicationStartupManager* self,
                                                 GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (APPLICATION_IS_STARTUP_MANAGER (self));
	{
		GFile* _tmp0_;
		_tmp0_ = self->priv->startup_file;
		g_file_delete (_tmp0_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
				goto __catch63_g_io_error_not_found;
			}
			goto __finally63;
		}
	}
	goto __finally63;
	__catch63_g_io_error_not_found:
	{
		GError* err = NULL;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_g_error_free0 (err);
	}
	__finally63:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}

void
application_startup_manager_sync_with_config (ApplicationStartupManager* self)
{
	Configuration* _tmp0_;
	GFile* _tmp1_;
	g_return_if_fail (APPLICATION_IS_STARTUP_MANAGER (self));
	_tmp0_ = self->priv->config;
	_tmp1_ = self->priv->startup_file;
	configuration_set_startup_notifications (_tmp0_, g_file_query_exists (_tmp1_, NULL));
}

static void
application_startup_manager_on_startup_notification_change (ApplicationStartupManager* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (APPLICATION_IS_STARTUP_MANAGER (self));
	{
		Configuration* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp0_ = self->priv->config;
		_tmp1_ = configuration_get_startup_notifications (_tmp0_);
		_tmp2_ = _tmp1_;
		if (_tmp2_) {
			application_startup_manager_install_startup_file (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch64_g_error;
			}
		} else {
			application_startup_manager_delete_startup_file (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch64_g_error;
			}
		}
	}
	goto __finally64;
	__catch64_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = err;
		_tmp4_ = _tmp3_->message;
		g_warning ("application-startup-manager.vala:88: Failed to update autostart deskto" \
"p file: %s", _tmp4_);
		_g_error_free0 (err);
	}
	__finally64:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
application_startup_manager_class_init (ApplicationStartupManagerClass * klass,
                                        gpointer klass_data)
{
	application_startup_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ApplicationStartupManager_private_offset);
	G_OBJECT_CLASS (klass)->finalize = application_startup_manager_finalize;
}

static void
application_startup_manager_instance_init (ApplicationStartupManager * self,
                                           gpointer klass)
{
	self->priv = application_startup_manager_get_instance_private (self);
}

static void
application_startup_manager_finalize (GObject * obj)
{
	ApplicationStartupManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_STARTUP_MANAGER, ApplicationStartupManager);
	_configuration_unref0 (self->priv->config);
	_g_object_unref0 (self->priv->installed_file);
	_g_object_unref0 (self->priv->startup_file);
	G_OBJECT_CLASS (application_startup_manager_parent_class)->finalize (obj);
}

GType
application_startup_manager_get_type (void)
{
	static volatile gsize application_startup_manager_type_id__volatile = 0;
	if (g_once_init_enter (&application_startup_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ApplicationStartupManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_startup_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationStartupManager), 0, (GInstanceInitFunc) application_startup_manager_instance_init, NULL };
		GType application_startup_manager_type_id;
		application_startup_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ApplicationStartupManager", &g_define_type_info, 0);
		ApplicationStartupManager_private_offset = g_type_add_instance_private (application_startup_manager_type_id, sizeof (ApplicationStartupManagerPrivate));
		g_once_init_leave (&application_startup_manager_type_id__volatile, application_startup_manager_type_id);
	}
	return application_startup_manager_type_id__volatile;
}

