/* email-entry.c generated by valac 0.44.7, the Vala compiler
 * generated from email-entry.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* A custom entry for e-mail addresses*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "geary-engine.h"
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_EMAIL_ENTRY (email_entry_get_type ())
#define EMAIL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EMAIL_ENTRY, EmailEntry))
#define EMAIL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EMAIL_ENTRY, EmailEntryClass))
#define IS_EMAIL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EMAIL_ENTRY))
#define IS_EMAIL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EMAIL_ENTRY))
#define EMAIL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EMAIL_ENTRY, EmailEntryClass))

typedef struct _EmailEntry EmailEntry;
typedef struct _EmailEntryClass EmailEntryClass;
typedef struct _EmailEntryPrivate EmailEntryPrivate;

#define TYPE_COMPOSER_WIDGET (composer_widget_get_type ())
#define COMPOSER_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPOSER_WIDGET, ComposerWidget))
#define COMPOSER_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPOSER_WIDGET, ComposerWidgetClass))
#define IS_COMPOSER_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPOSER_WIDGET))
#define IS_COMPOSER_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPOSER_WIDGET))
#define COMPOSER_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPOSER_WIDGET, ComposerWidgetClass))

typedef struct _ComposerWidget ComposerWidget;
typedef struct _ComposerWidgetClass ComposerWidgetClass;
enum  {
	EMAIL_ENTRY_0_PROPERTY,
	EMAIL_ENTRY_VALID_PROPERTY,
	EMAIL_ENTRY_EMPTY_PROPERTY,
	EMAIL_ENTRY_ADDRESSES_PROPERTY,
	EMAIL_ENTRY_NUM_PROPERTIES
};
static GParamSpec* email_entry_properties[EMAIL_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_CONTACT_ENTRY_COMPLETION (contact_entry_completion_get_type ())
#define CONTACT_ENTRY_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletion))
#define CONTACT_ENTRY_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletionClass))
#define IS_CONTACT_ENTRY_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTACT_ENTRY_COMPLETION))
#define IS_CONTACT_ENTRY_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTACT_ENTRY_COMPLETION))
#define CONTACT_ENTRY_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletionClass))

typedef struct _ContactEntryCompletion ContactEntryCompletion;
typedef struct _ContactEntryCompletionClass ContactEntryCompletionClass;

struct _EmailEntry {
	GtkEntry parent_instance;
	EmailEntryPrivate * priv;
	gboolean modified;
};

struct _EmailEntryClass {
	GtkEntryClass parent_class;
};

struct _EmailEntryPrivate {
	gboolean _valid;
	gboolean _empty;
	GearyRFC822MailboxAddresses* _addresses;
	ComposerWidget* composer;
	gboolean updating;
};

static gint EmailEntry_private_offset;
static gpointer email_entry_parent_class = NULL;

GType email_entry_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EmailEntry, g_object_unref)
GType composer_widget_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComposerWidget, g_object_unref)
EmailEntry* email_entry_new (ComposerWidget* composer);
EmailEntry* email_entry_construct (GType object_type,
                                   ComposerWidget* composer);
static void email_entry_on_changed (EmailEntry* self);
static void _email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender,
                                                   gpointer self);
static gboolean email_entry_on_key_press (EmailEntry* self,
                                   GtkWidget* widget,
                                   GdkEventKey* event);
static gboolean _email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                               GdkEventKey* event,
                                                               gpointer self);
static void __lambda52_ (EmailEntry* self);
static void email_entry_validate_addresses (EmailEntry* self);
GearyRFC822MailboxAddresses* email_entry_get_addresses (EmailEntry* self);
static void ___lambda52__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
GType contact_entry_completion_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactEntryCompletion, g_object_unref)
void contact_entry_completion_update_model (ContactEntryCompletion* self);
void email_entry_set_addresses (EmailEntry* self,
                                GearyRFC822MailboxAddresses* value);
void email_entry_set_valid (EmailEntry* self,
                            gboolean value);
void email_entry_set_empty (EmailEntry* self,
                            gboolean value);
void contact_entry_completion_trigger_selection (ContactEntryCompletion* self);
gboolean email_entry_get_valid (EmailEntry* self);
gboolean email_entry_get_empty (EmailEntry* self);
static void email_entry_finalize (GObject * obj);
static void _vala_email_entry_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_email_entry_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
email_entry_get_instance_private (EmailEntry* self)
{
	return G_STRUCT_MEMBER_P (self, EmailEntry_private_offset);
}

static void
_email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender,
                                              gpointer self)
{
	email_entry_on_changed ((EmailEntry*) self);
}

static gboolean
_email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                      GdkEventKey* event,
                                                      gpointer self)
{
	gboolean result;
	result = email_entry_on_key_press ((EmailEntry*) self, _sender, event);
	return result;
}

static void
__lambda52_ (EmailEntry* self)
{
	gchar* _tmp0_ = NULL;
	GearyRFC822MailboxAddresses* _tmp1_;
	email_entry_validate_addresses (self);
	if (self->priv->updating) {
		return;
	}
	self->priv->updating = TRUE;
	self->modified = TRUE;
	_tmp1_ = self->priv->_addresses;
	if (_tmp1_ == NULL) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	} else {
		GearyRFC822MailboxAddresses* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = self->priv->_addresses;
		_tmp4_ = geary_rf_c822_mailbox_addresses_to_full_display (_tmp3_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), _tmp0_);
	self->priv->updating = FALSE;
	_g_free0 (_tmp0_);
}

static void
___lambda52__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda52_ ((EmailEntry*) self);
}

EmailEntry*
email_entry_construct (GType object_type,
                       ComposerWidget* composer)
{
	EmailEntry * self = NULL;
	g_return_val_if_fail (IS_COMPOSER_WIDGET (composer), NULL);
	self = (EmailEntry*) g_object_new (object_type, NULL);
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_editable_get_type (), GtkEditable), "changed", (GCallback) _email_entry_on_changed_gtk_editable_changed, self, 0);
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _email_entry_on_key_press_gtk_widget_key_press_event, self, 0);
	self->priv->composer = composer;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::addresses", (GCallback) ___lambda52__g_object_notify, self, 0);
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	return self;
}

EmailEntry*
email_entry_new (ComposerWidget* composer)
{
	return email_entry_construct (TYPE_EMAIL_ENTRY, composer);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}

static void
email_entry_on_changed (EmailEntry* self)
{
	ContactEntryCompletion* completion = NULL;
	GtkEntryCompletion* _tmp0_;
	ContactEntryCompletion* _tmp1_;
	ContactEntryCompletion* _tmp2_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GearyRFC822MailboxAddresses* _tmp11_;
	GearyRFC822MailboxAddresses* _tmp12_;
	g_return_if_fail (IS_EMAIL_ENTRY (self));
	if (self->priv->updating) {
		return;
	}
	self->modified = TRUE;
	_tmp0_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
	_tmp1_ = _g_object_ref0 (IS_CONTACT_ENTRY_COMPLETION (_tmp0_) ? ((ContactEntryCompletion*) _tmp0_) : NULL);
	completion = _tmp1_;
	_tmp2_ = completion;
	if (_tmp2_ != NULL) {
		ContactEntryCompletion* _tmp3_;
		_tmp3_ = completion;
		contact_entry_completion_update_model (_tmp3_);
	}
	_tmp4_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
	_tmp5_ = _tmp4_;
	_tmp6_ = string_strip (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = geary_string_is_empty (_tmp7_);
	_g_free0 (_tmp7_);
	if (_tmp8_) {
		self->priv->updating = TRUE;
		email_entry_set_addresses (self, NULL);
		self->priv->updating = FALSE;
		email_entry_set_valid (self, FALSE);
		email_entry_set_empty (self, TRUE);
		_g_object_unref0 (completion);
		return;
	}
	self->priv->updating = TRUE;
	_tmp9_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
	_tmp10_ = _tmp9_;
	_tmp11_ = geary_rf_c822_mailbox_addresses_new_from_rfc822_string (_tmp10_);
	_tmp12_ = _tmp11_;
	email_entry_set_addresses (self, _tmp12_);
	_g_object_unref0 (_tmp12_);
	self->priv->updating = FALSE;
	_g_object_unref0 (completion);
}

static void
email_entry_validate_addresses (EmailEntry* self)
{
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* _tmp1_;
	g_return_if_fail (IS_EMAIL_ENTRY (self));
	_tmp1_ = self->priv->_addresses;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GearyRFC822MailboxAddresses* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->_addresses;
		_tmp3_ = geary_rf_c822_mailbox_addresses_get_size (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == 0;
	}
	if (_tmp0_) {
		email_entry_set_valid (self, FALSE);
		email_entry_set_empty (self, TRUE);
		return;
	}
	email_entry_set_empty (self, FALSE);
	{
		GearyRFC822MailboxAddresses* _address_list = NULL;
		GearyRFC822MailboxAddresses* _tmp5_;
		GearyRFC822MailboxAddresses* _tmp6_;
		gint _address_size = 0;
		GearyRFC822MailboxAddresses* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _address_index = 0;
		_tmp5_ = self->priv->_addresses;
		_tmp6_ = _g_object_ref0 (_tmp5_);
		_address_list = _tmp6_;
		_tmp7_ = _address_list;
		_tmp8_ = geary_rf_c822_mailbox_addresses_get_size (_tmp7_);
		_tmp9_ = _tmp8_;
		_address_size = _tmp9_;
		_address_index = -1;
		while (TRUE) {
			GearyRFC822MailboxAddress* address = NULL;
			GearyRFC822MailboxAddresses* _tmp10_;
			GearyRFC822MailboxAddress* _tmp11_;
			GearyRFC822MailboxAddress* _tmp12_;
			_address_index = _address_index + 1;
			if (!(_address_index < _address_size)) {
				break;
			}
			_tmp10_ = _address_list;
			_tmp11_ = geary_rf_c822_mailbox_addresses_get (_tmp10_, _address_index);
			address = _tmp11_;
			_tmp12_ = address;
			if (!geary_rf_c822_mailbox_address_is_valid (_tmp12_)) {
				email_entry_set_valid (self, FALSE);
				_g_object_unref0 (address);
				_g_object_unref0 (_address_list);
				return;
			}
			_g_object_unref0 (address);
		}
		_g_object_unref0 (_address_list);
	}
	email_entry_set_valid (self, TRUE);
}

static gboolean
email_entry_on_key_press (EmailEntry* self,
                          GtkWidget* widget,
                          GdkEventKey* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()), FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->keyval == GDK_KEY_Tab) {
		GtkEntryCompletion* _tmp0_;
		ComposerWidget* _tmp1_;
		_tmp0_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
		contact_entry_completion_trigger_selection (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletion));
		_tmp1_ = self->priv->composer;
		gtk_widget_child_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), GTK_DIR_TAB_FORWARD);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

gboolean
email_entry_get_valid (EmailEntry* self)
{
	gboolean result;
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
	result = self->priv->_valid;
	return result;
}

void
email_entry_set_valid (EmailEntry* self,
                       gboolean value)
{
	g_return_if_fail (IS_EMAIL_ENTRY (self));
	if (email_entry_get_valid (self) != value) {
		self->priv->_valid = value;
		g_object_notify_by_pspec ((GObject *) self, email_entry_properties[EMAIL_ENTRY_VALID_PROPERTY]);
	}
}

gboolean
email_entry_get_empty (EmailEntry* self)
{
	gboolean result;
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
	result = self->priv->_empty;
	return result;
}

void
email_entry_set_empty (EmailEntry* self,
                       gboolean value)
{
	g_return_if_fail (IS_EMAIL_ENTRY (self));
	if (email_entry_get_empty (self) != value) {
		self->priv->_empty = value;
		g_object_notify_by_pspec ((GObject *) self, email_entry_properties[EMAIL_ENTRY_EMPTY_PROPERTY]);
	}
}

GearyRFC822MailboxAddresses*
email_entry_get_addresses (EmailEntry* self)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822MailboxAddresses* _tmp0_;
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), NULL);
	_tmp0_ = self->priv->_addresses;
	result = _tmp0_;
	return result;
}

void
email_entry_set_addresses (EmailEntry* self,
                           GearyRFC822MailboxAddresses* value)
{
	g_return_if_fail (IS_EMAIL_ENTRY (self));
	if (email_entry_get_addresses (self) != value) {
		GearyRFC822MailboxAddresses* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_addresses);
		self->priv->_addresses = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, email_entry_properties[EMAIL_ENTRY_ADDRESSES_PROPERTY]);
	}
}

static void
email_entry_class_init (EmailEntryClass * klass,
                        gpointer klass_data)
{
	email_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &EmailEntry_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_email_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_email_entry_set_property;
	G_OBJECT_CLASS (klass)->finalize = email_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_VALID_PROPERTY, email_entry_properties[EMAIL_ENTRY_VALID_PROPERTY] = g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_EMPTY_PROPERTY, email_entry_properties[EMAIL_ENTRY_EMPTY_PROPERTY] = g_param_spec_boolean ("empty", "empty", "empty", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_ADDRESSES_PROPERTY, email_entry_properties[EMAIL_ENTRY_ADDRESSES_PROPERTY] = g_param_spec_object ("addresses", "addresses", "addresses", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
email_entry_instance_init (EmailEntry * self,
                           gpointer klass)
{
	self->priv = email_entry_get_instance_private (self);
	self->priv->_valid = FALSE;
	self->priv->_empty = TRUE;
	self->modified = FALSE;
	self->priv->_addresses = NULL;
	self->priv->updating = FALSE;
}

static void
email_entry_finalize (GObject * obj)
{
	EmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EMAIL_ENTRY, EmailEntry);
	_g_object_unref0 (self->priv->_addresses);
	G_OBJECT_CLASS (email_entry_parent_class)->finalize (obj);
}

GType
email_entry_get_type (void)
{
	static volatile gsize email_entry_type_id__volatile = 0;
	if (g_once_init_enter (&email_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EmailEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) email_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EmailEntry), 0, (GInstanceInitFunc) email_entry_instance_init, NULL };
		GType email_entry_type_id;
		email_entry_type_id = g_type_register_static (gtk_entry_get_type (), "EmailEntry", &g_define_type_info, 0);
		EmailEntry_private_offset = g_type_add_instance_private (email_entry_type_id, sizeof (EmailEntryPrivate));
		g_once_init_leave (&email_entry_type_id__volatile, email_entry_type_id);
	}
	return email_entry_type_id__volatile;
}

static void
_vala_email_entry_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	EmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EMAIL_ENTRY, EmailEntry);
	switch (property_id) {
		case EMAIL_ENTRY_VALID_PROPERTY:
		g_value_set_boolean (value, email_entry_get_valid (self));
		break;
		case EMAIL_ENTRY_EMPTY_PROPERTY:
		g_value_set_boolean (value, email_entry_get_empty (self));
		break;
		case EMAIL_ENTRY_ADDRESSES_PROPERTY:
		g_value_set_object (value, email_entry_get_addresses (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_email_entry_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	EmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EMAIL_ENTRY, EmailEntry);
	switch (property_id) {
		case EMAIL_ENTRY_VALID_PROPERTY:
		email_entry_set_valid (self, g_value_get_boolean (value));
		break;
		case EMAIL_ENTRY_EMPTY_PROPERTY:
		email_entry_set_empty (self, g_value_get_boolean (value));
		break;
		case EMAIL_ENTRY_ADDRESSES_PROPERTY:
		email_entry_set_addresses (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

