/* util-gtk.c generated by valac 0.44.7, the Vala compiler
 * generated from util-gtk.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef void (*GtkUtilMenuForeachFunc) (const gchar* label, const gchar* action_name, GVariant* target, GMenu* section, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

void gtk_util_set_source_color_from_string (cairo_t* ctx,
                                            const gchar* spec);
gboolean gtk_util_close_button_at_end (void);
void gtk_util_menu_foreach (GMenu* menu,
                            GtkUtilMenuForeachFunc foreach_func,
                            gpointer foreach_func_target);
gint gtk_util_get_border_box_height (GtkWidget* widget);

/**
 * Given an HTML-style color spec, parses the color and sets it to the source RGB of the Cairo context.
 * (Borrowed from Shotwell.)
 */
void
gtk_util_set_source_color_from_string (cairo_t* ctx,
                                       const gchar* spec)
{
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (spec != NULL);
	memset (&rgba, 0, sizeof (GdkRGBA));
	if (!gdk_rgba_parse (&rgba, spec)) {
		g_error ("util-gtk.vala:16: Can't parse color %s", spec);
	}
	_tmp0_ = rgba;
	_tmp1_ = rgba;
	_tmp2_ = rgba;
	cairo_set_source_rgb (ctx, _tmp0_.red, _tmp1_.green, _tmp2_.blue);
}

/**
 * Returns whether the close button is at the end of the headerbar.
 */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

gboolean
gtk_util_close_button_at_end (void)
{
	gboolean result = FALSE;
	gchar* layout = NULL;
	GtkSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean at_end = FALSE;
	const gchar* _tmp3_;
	_tmp0_ = gtk_settings_get_default ();
	g_object_get (_tmp0_, "gtk-decoration-layout", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	layout = _tmp2_;
	at_end = FALSE;
	_tmp3_ = layout;
	if (_tmp3_ != NULL) {
		gint colon_ind = 0;
		const gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		_tmp4_ = layout;
		colon_ind = string_index_of (_tmp4_, ":", 0);
		if (colon_ind >= 0) {
			const gchar* _tmp6_;
			_tmp6_ = layout;
			_tmp5_ = string_index_of (_tmp6_, "close", colon_ind) >= 0;
		} else {
			_tmp5_ = FALSE;
		}
		at_end = _tmp5_;
	}
	result = at_end;
	_g_free0 (layout);
	return result;
}

/**
 * Allows iterating over a GMenu, without having to handle MenuItems
 * @param menu - The menu to iterate over
 * @param foreach_func - The function which will be called on the attributes of menu's children
 */
void
gtk_util_menu_foreach (GMenu* menu,
                       GtkUtilMenuForeachFunc foreach_func,
                       gpointer foreach_func_target)
{
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (menu, g_menu_get_type ()));
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GVariant* label = NULL;
				const GVariantType* _tmp2_;
				GVariant* _tmp3_;
				GVariant* action_name = NULL;
				const GVariantType* _tmp4_;
				GVariant* _tmp5_;
				GVariant* action_target = NULL;
				const GVariantType* _tmp6_;
				GVariant* _tmp7_;
				GMenu* section = NULL;
				GMenuModel* _tmp8_;
				const gchar* _tmp9_ = NULL;
				GVariant* _tmp10_;
				const gchar* _tmp13_ = NULL;
				GVariant* _tmp14_;
				GVariant* _tmp17_;
				GMenu* _tmp18_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < g_menu_model_get_n_items (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel)))) {
					break;
				}
				_tmp2_ = G_VARIANT_TYPE_STRING;
				_tmp3_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_LABEL, _tmp2_);
				label = _tmp3_;
				_tmp4_ = G_VARIANT_TYPE_STRING;
				_tmp5_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_ACTION, _tmp4_);
				action_name = _tmp5_;
				_tmp6_ = G_VARIANT_TYPE_STRING;
				_tmp7_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_TARGET, _tmp6_);
				action_target = _tmp7_;
				_tmp8_ = g_menu_model_get_item_link (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_LINK_SECTION);
				section = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_get_type (), GMenu);
				_tmp10_ = label;
				if (_tmp10_ != NULL) {
					GVariant* _tmp11_;
					const gchar* _tmp12_;
					_tmp11_ = label;
					_tmp12_ = g_variant_get_string (_tmp11_, NULL);
					_tmp9_ = _tmp12_;
				} else {
					_tmp9_ = NULL;
				}
				_tmp14_ = action_name;
				if (_tmp14_ != NULL) {
					GVariant* _tmp15_;
					const gchar* _tmp16_;
					_tmp15_ = action_name;
					_tmp16_ = g_variant_get_string (_tmp15_, NULL);
					_tmp13_ = _tmp16_;
				} else {
					_tmp13_ = NULL;
				}
				_tmp17_ = action_target;
				_tmp18_ = section;
				foreach_func (_tmp9_, _tmp13_, _tmp17_, _tmp18_, foreach_func_target);
				_g_object_unref0 (section);
				_g_variant_unref0 (action_target);
				_g_variant_unref0 (action_name);
				_g_variant_unref0 (label);
			}
		}
	}
}

/**
 * Returns the CSS border box height for a widget.
 *
 * This adjusts the GTK widget's allocated height to exclude extra
 * space added by the CSS margin property, if any.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

inline gint
gtk_util_get_border_box_height (GtkWidget* widget)
{
	gint result = 0;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags flags = 0U;
	GtkBorder margin = {0};
	GtkBorder _tmp2_ = {0};
	GtkBorder _tmp3_;
	GtkBorder _tmp4_;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()), 0);
	_tmp0_ = gtk_widget_get_style_context (widget);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style = _tmp1_;
	flags = gtk_style_context_get_state (style);
	gtk_style_context_get_margin (style, flags, &_tmp2_);
	margin = _tmp2_;
	_tmp3_ = margin;
	_tmp4_ = margin;
	result = (gtk_widget_get_allocated_height (widget) - _tmp3_.top) - _tmp4_.bottom;
	_g_object_unref0 (style);
	return result;
}

