/* util-migrate.c generated by valac 0.44.7, the Vala compiler
 * generated from util-migrate.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "geary-engine.h"

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define MIGRATE_GROUP "AccountInformation"
#define MIGRATE_PRIMARY_EMAIL_KEY "primary_email"
#define ACCOUNTS_MANAGER_SETTINGS_FILENAME "geary.ini"
#define MIGRATE_SETTINGS_FILENAME ACCOUNTS_MANAGER_SETTINGS_FILENAME
#define MIGRATE_MIGRATED_FILENAME ".config_migrated"
void migrate_xdg_config_dir (GFile* user_data_dir,
                             GFile* user_config_dir,
                             GError** error);
#define MIGRATE_OLD_APP_ID "org.yorba.geary"
#define MIGRATE_MIGRATED_CONFIG_KEY "migrated-config"
void migrate_old_app_config (GSettings* newSettings,
                             const gchar* old_app_id);
#define GEARY_APPLICATION_GSETTINGS_DIR _GSETTINGS_DIR
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

/**
     * Migrates geary.ini to the XDG configuration directory with the account's email address
     *
     * This function iterates through all the account directories in $XDG_DATA_DIR and copies over
     * geary.ini to ~/.config/geary/<account>/geary.ini. Note that it leaves the
     * original file untouched.
     * It also appends a "primary_email" key to the new configuration file to reliaby keep
     * track of the user's email address.
     */
static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	if (result_length1) {
		*result_length1 = _tmp3__length1;
	}
	result = _tmp3_;
	return result;
}

void
migrate_xdg_config_dir (GFile* user_data_dir,
                        GFile* user_config_dir,
                        GError** error)
{
	GFile* new_config_dir = NULL;
	GFile* old_data_dir = NULL;
	GFile* new_config_file = NULL;
	GFile* old_config_file = NULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileEnumerator* _tmp5_;
	GFileInfo* info = NULL;
	gchar* email = NULL;
	GFile* is_migrated = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (user_data_dir, g_file_get_type ()));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (user_config_dir, g_file_get_type ()));
	{
		g_file_make_directory_with_parents (user_config_dir, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch192_g_error;
		}
	}
	goto __finally192;
	__catch192_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = err;
		if (!g_error_matches (_tmp0_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
			GError* _tmp1_;
			GError* _tmp2_;
			_tmp1_ = err;
			_tmp2_ = _g_error_copy0 (_tmp1_);
			_inner_error0_ = _tmp2_;
			_g_error_free0 (err);
			goto __finally192;
		}
		_g_error_free0 (err);
	}
	__finally192:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (old_config_file);
		_g_object_unref0 (new_config_file);
		_g_object_unref0 (old_data_dir);
		_g_object_unref0 (new_config_dir);
		return;
	}
	if (!g_file_query_exists (user_data_dir, NULL)) {
		_g_object_unref0 (old_config_file);
		_g_object_unref0 (new_config_file);
		_g_object_unref0 (old_data_dir);
		_g_object_unref0 (new_config_dir);
		return;
	}
	_tmp4_ = g_file_enumerate_children (user_data_dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
	_tmp3_ = _tmp4_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (enumerator);
		_g_object_unref0 (old_config_file);
		_g_object_unref0 (new_config_file);
		_g_object_unref0 (old_data_dir);
		_g_object_unref0 (new_config_dir);
		return;
	}
	_tmp5_ = _tmp3_;
	_tmp3_ = NULL;
	_g_object_unref0 (enumerator);
	enumerator = _tmp5_;
	while (TRUE) {
		GFileInfo* _tmp6_ = NULL;
		GFileEnumerator* _tmp7_;
		GFileInfo* _tmp8_;
		GFileInfo* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		GFile* _tmp17_;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp38_;
		GKeyFile* _tmp46_;
		const gchar* _tmp47_;
		gchar* data = NULL;
		GKeyFile* _tmp48_;
		gchar* _tmp49_;
		GFile* _tmp55_;
		GFileOutputStream* _tmp56_;
		GFileOutputStream* _tmp57_;
		_tmp7_ = enumerator;
		_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error0_);
		_tmp6_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (is_migrated);
			_g_free0 (email);
			_g_object_unref0 (info);
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (old_config_file);
			_g_object_unref0 (new_config_file);
			_g_object_unref0 (old_data_dir);
			_g_object_unref0 (new_config_dir);
			return;
		}
		_tmp9_ = _tmp6_;
		_tmp6_ = NULL;
		_g_object_unref0 (info);
		info = _tmp9_;
		_tmp10_ = info;
		if (!(_tmp10_ != NULL)) {
			_g_object_unref0 (_tmp6_);
			break;
		}
		_tmp11_ = info;
		if (g_file_info_get_file_type (_tmp11_) != G_FILE_TYPE_DIRECTORY) {
			_g_object_unref0 (_tmp6_);
			continue;
		}
		_tmp12_ = info;
		_tmp13_ = g_file_info_get_name (_tmp12_);
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (email);
		email = _tmp14_;
		_tmp15_ = email;
		if (!geary_rf_c822_mailbox_address_is_valid_address (_tmp15_)) {
			_g_object_unref0 (_tmp6_);
			continue;
		}
		_tmp16_ = email;
		_tmp17_ = g_file_get_child (user_data_dir, _tmp16_);
		_g_object_unref0 (old_data_dir);
		old_data_dir = _tmp17_;
		_tmp18_ = email;
		_tmp19_ = g_file_get_child (user_config_dir, _tmp18_);
		_g_object_unref0 (new_config_dir);
		new_config_dir = _tmp19_;
		_tmp20_ = old_data_dir;
		_tmp21_ = g_file_get_child (_tmp20_, MIGRATE_SETTINGS_FILENAME);
		_g_object_unref0 (old_config_file);
		old_config_file = _tmp21_;
		_tmp22_ = old_config_file;
		if (!g_file_query_exists (_tmp22_, NULL)) {
			_g_object_unref0 (_tmp6_);
			continue;
		}
		_tmp23_ = old_data_dir;
		_tmp24_ = g_file_get_child (_tmp23_, MIGRATE_MIGRATED_FILENAME);
		_g_object_unref0 (is_migrated);
		is_migrated = _tmp24_;
		_tmp25_ = is_migrated;
		if (g_file_query_exists (_tmp25_, NULL)) {
			_g_object_unref0 (_tmp6_);
			continue;
		}
		_tmp26_ = new_config_dir;
		if (!g_file_query_exists (_tmp26_, NULL)) {
			{
				GFile* _tmp27_;
				_tmp27_ = new_config_dir;
				g_file_make_directory_with_parents (_tmp27_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch193_g_error;
				}
			}
			goto __finally193;
			__catch193_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp28_ = e;
				_tmp29_ = _tmp28_->message;
				g_debug ("util-migrate.vala:75: Cannot make directory, %s", _tmp29_);
				_g_error_free0 (e);
				_g_object_unref0 (_tmp6_);
				continue;
			}
			__finally193:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (_tmp6_);
				_g_object_unref0 (is_migrated);
				_g_free0 (email);
				_g_object_unref0 (info);
				_g_object_unref0 (_tmp3_);
				_g_object_unref0 (enumerator);
				_g_object_unref0 (old_config_file);
				_g_object_unref0 (new_config_file);
				_g_object_unref0 (old_data_dir);
				_g_object_unref0 (new_config_dir);
				return;
			}
		}
		_tmp30_ = new_config_dir;
		_tmp31_ = g_file_get_child (_tmp30_, MIGRATE_SETTINGS_FILENAME);
		_g_object_unref0 (new_config_file);
		new_config_file = _tmp31_;
		_tmp32_ = new_config_file;
		if (g_file_query_exists (_tmp32_, NULL)) {
			_g_object_unref0 (_tmp6_);
			continue;
		}
		{
			GFile* _tmp33_;
			GFile* _tmp34_;
			_tmp33_ = old_config_file;
			_tmp34_ = new_config_file;
			g_file_copy (_tmp33_, _tmp34_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch194_g_error;
			}
		}
		goto __finally194;
		__catch194_g_error:
		{
			GError* err = NULL;
			GFile* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			err = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp35_ = new_config_dir;
			_tmp36_ = g_file_get_path (_tmp35_);
			_tmp37_ = _tmp36_;
			g_debug ("util-migrate.vala:87: Error copying over to %s", _tmp37_);
			_g_free0 (_tmp37_);
			_g_error_free0 (err);
			_g_object_unref0 (_tmp6_);
			continue;
		}
		__finally194:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (is_migrated);
			_g_free0 (email);
			_g_object_unref0 (info);
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (old_config_file);
			_g_object_unref0 (new_config_file);
			_g_object_unref0 (old_data_dir);
			_g_object_unref0 (new_config_dir);
			return;
		}
		_tmp38_ = g_key_file_new ();
		key_file = _tmp38_;
		{
			GKeyFile* _tmp39_;
			GFile* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			_tmp39_ = key_file;
			_tmp40_ = new_config_file;
			_tmp41_ = g_file_get_path (_tmp40_);
			_tmp42_ = _tmp41_;
			g_key_file_load_from_file (_tmp39_, _tmp42_, G_KEY_FILE_NONE, &_inner_error0_);
			_g_free0 (_tmp42_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch195_g_error;
			}
		}
		goto __finally195;
		__catch195_g_error:
		{
			GError* err = NULL;
			GFile* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			err = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp43_ = new_config_file;
			_tmp44_ = g_file_get_path (_tmp43_);
			_tmp45_ = _tmp44_;
			g_debug ("util-migrate.vala:94: Error opening %s", _tmp45_);
			_g_free0 (_tmp45_);
			_g_error_free0 (err);
			_g_key_file_unref0 (key_file);
			_g_object_unref0 (_tmp6_);
			continue;
		}
		__finally195:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_key_file_unref0 (key_file);
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (is_migrated);
			_g_free0 (email);
			_g_object_unref0 (info);
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (old_config_file);
			_g_object_unref0 (new_config_file);
			_g_object_unref0 (old_data_dir);
			_g_object_unref0 (new_config_dir);
			return;
		}
		_tmp46_ = key_file;
		_tmp47_ = email;
		g_key_file_set_value (_tmp46_, MIGRATE_GROUP, MIGRATE_PRIMARY_EMAIL_KEY, _tmp47_);
		_tmp48_ = key_file;
		_tmp49_ = g_key_file_to_data (_tmp48_, NULL, NULL);
		data = _tmp49_;
		{
			GFile* _tmp50_;
			const gchar* _tmp51_;
			guint8* _tmp52_;
			gint _tmp52__length1;
			guint8* _tmp53_;
			gint _tmp53__length1;
			_tmp50_ = new_config_file;
			_tmp51_ = data;
			_tmp52_ = string_get_data (_tmp51_, &_tmp52__length1);
			_tmp53_ = _tmp52_;
			_tmp53__length1 = _tmp52__length1;
			g_file_replace_contents (_tmp50_, _tmp53_, (gsize) _tmp53__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch196_g_error;
			}
		}
		goto __finally196;
		__catch196_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp54_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp54_ = email;
			g_debug ("util-migrate.vala:105: Error writing email %s to config file", _tmp54_);
			_g_error_free0 (e);
			_g_free0 (data);
			_g_key_file_unref0 (key_file);
			_g_object_unref0 (_tmp6_);
			continue;
		}
		__finally196:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (data);
			_g_key_file_unref0 (key_file);
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (is_migrated);
			_g_free0 (email);
			_g_object_unref0 (info);
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (old_config_file);
			_g_object_unref0 (new_config_file);
			_g_object_unref0 (old_data_dir);
			_g_object_unref0 (new_config_dir);
			return;
		}
		_tmp55_ = is_migrated;
		_tmp56_ = g_file_create (_tmp55_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
		_tmp57_ = _tmp56_;
		_g_object_unref0 (_tmp57_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (data);
			_g_key_file_unref0 (key_file);
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (is_migrated);
			_g_free0 (email);
			_g_object_unref0 (info);
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (old_config_file);
			_g_object_unref0 (new_config_file);
			_g_object_unref0 (old_data_dir);
			_g_object_unref0 (new_config_dir);
			return;
		}
		_g_free0 (data);
		_g_key_file_unref0 (key_file);
		_g_object_unref0 (_tmp6_);
	}
	_g_object_unref0 (is_migrated);
	_g_free0 (email);
	_g_object_unref0 (info);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (enumerator);
	_g_object_unref0 (old_config_file);
	_g_object_unref0 (new_config_file);
	_g_object_unref0 (old_data_dir);
	_g_object_unref0 (new_config_dir);
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
	return self ? g_settings_schema_source_ref (self) : NULL;
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

void
migrate_old_app_config (GSettings* newSettings,
                        const gchar* old_app_id)
{
	GSettingsSchemaSource* schemaSource = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchemaSource* _tmp1_;
	GSettingsSchema* oldSettingsSchema = NULL;
	GSettingsSchemaSource* _tmp5_;
	GSettingsSchema* _tmp6_;
	GSettingsSchema* _tmp7_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (newSettings, g_settings_get_type ()));
	g_return_if_fail (old_app_id != NULL);
	_tmp0_ = g_settings_schema_source_get_default ();
	_tmp1_ = _g_settings_schema_source_ref0 (_tmp0_);
	schemaSource = _tmp1_;
	if (GEARY_APPLICATION_GSETTINGS_DIR != NULL) {
		{
			GSettingsSchemaSource* _tmp2_ = NULL;
			GSettingsSchemaSource* _tmp3_;
			GSettingsSchemaSource* _tmp4_;
			_tmp3_ = g_settings_schema_source_new_from_directory (GEARY_APPLICATION_GSETTINGS_DIR, NULL, FALSE, &_inner_error0_);
			_tmp2_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch197_g_error;
			}
			_tmp4_ = _tmp2_;
			_tmp2_ = NULL;
			_g_settings_schema_source_unref0 (schemaSource);
			schemaSource = _tmp4_;
			_g_settings_schema_source_unref0 (_tmp2_);
		}
		goto __finally197;
		__catch197_g_error:
		{
			GError* e = NULL;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_g_error_free0 (e);
		}
		__finally197:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_settings_schema_source_unref0 (schemaSource);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp5_ = schemaSource;
	_tmp6_ = g_settings_schema_source_lookup (_tmp5_, old_app_id, FALSE);
	oldSettingsSchema = _tmp6_;
	if (g_settings_get_boolean (newSettings, MIGRATE_MIGRATED_CONFIG_KEY)) {
		_g_settings_schema_unref0 (oldSettingsSchema);
		_g_settings_schema_source_unref0 (schemaSource);
		return;
	}
	_tmp7_ = oldSettingsSchema;
	if (_tmp7_ != NULL) {
		GSettings* oldSettings = NULL;
		GSettingsSchema* _tmp8_;
		GSettings* _tmp9_;
		gchar** oldKeys = NULL;
		GSettings* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint oldKeys_length1;
		gint _oldKeys_size_;
		gchar** _tmp13_;
		gchar** _tmp14_;
		_tmp8_ = oldSettingsSchema;
		_tmp9_ = g_settings_new_full (_tmp8_, NULL, NULL);
		oldSettings = _tmp9_;
		_tmp10_ = oldSettings;
		_tmp12_ = _tmp11_ = g_settings_list_keys (_tmp10_);
		oldKeys = _tmp12_;
		oldKeys_length1 = _vala_array_length (_tmp11_);
		_oldKeys_size_ = oldKeys_length1;
		_tmp14_ = _tmp13_ = g_settings_list_keys (newSettings);
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
			key_collection = _tmp14_;
			key_collection_length1 = _vala_array_length (_tmp13_);
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
				gchar* _tmp15_;
				gchar* key = NULL;
				_tmp15_ = g_strdup (key_collection[key_it]);
				key = _tmp15_;
				{
					const gchar* _tmp16_;
					gchar** _tmp17_;
					gint _tmp17__length1;
					_tmp16_ = key;
					_tmp17_ = oldKeys;
					_tmp17__length1 = oldKeys_length1;
					if (_vala_string_array_contains (_tmp17_, _tmp17__length1, _tmp16_)) {
						const gchar* _tmp18_;
						GSettings* _tmp19_;
						const gchar* _tmp20_;
						GVariant* _tmp21_;
						GVariant* _tmp22_;
						_tmp18_ = key;
						_tmp19_ = oldSettings;
						_tmp20_ = key;
						_tmp21_ = g_settings_get_value (_tmp19_, _tmp20_);
						_tmp22_ = _tmp21_;
						g_settings_set_value (newSettings, _tmp18_, _tmp22_);
						_g_variant_unref0 (_tmp22_);
					}
					_g_free0 (key);
				}
			}
			key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
		}
		oldKeys = (_vala_array_free (oldKeys, oldKeys_length1, (GDestroyNotify) g_free), NULL);
		_g_object_unref0 (oldSettings);
	}
	g_settings_set_boolean (newSettings, MIGRATE_MIGRATED_CONFIG_KEY, TRUE);
	_g_settings_schema_unref0 (oldSettingsSchema);
	_g_settings_schema_source_unref0 (schemaSource);
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

