/* imap-data-format.c generated by valac 0.44.7, the Vala compiler
 * generated from imap-data-format.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED,
	GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL,
	GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED
} GearyImapDataFormatQuoting;

#define GEARY_IMAP_DATA_FORMAT_TYPE_QUOTING (geary_imap_data_format_quoting_get_type ())

GType geary_imap_data_format_quoting_get_type (void) G_GNUC_CONST;
gboolean geary_imap_data_format_is_special_char (gchar ch,
                                                 gchar* ar,
                                                 gint ar_length1,
                                                 const gchar* exceptions);
static gboolean _vala_char_array_contains (gchar * stack,
                                    int stack_length,
                                    const gchar needle);
gint geary_ascii_index_of (const gchar* str,
                           gchar ch);
gboolean geary_imap_data_format_is_atom_special (gchar ch,
                                                 const gchar* exceptions);
gboolean geary_imap_data_format_is_tag_special (gchar ch,
                                                const gchar* exceptions);
GearyImapDataFormatQuoting geary_imap_data_format_is_quoting_required (const gchar* str);
gboolean geary_string_is_empty (const gchar* str);
#define GEARY_STRING_EOS '\0'

const gchar GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS[9] = {'(', ')', '{', ' ', '%', '*', '"', '\\', ']'};
const gchar GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS[7] = {'(', ')', '{', '%', '\"', '\\', '+'};

GType
geary_imap_data_format_quoting_get_type (void)
{
	static volatile gsize geary_imap_data_format_quoting_type_id__volatile = 0;
	if (g_once_init_enter (&geary_imap_data_format_quoting_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED, "GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED", "required"}, {GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL, "GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL", "optional"}, {GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED, "GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED", "unallowed"}, {0, NULL, NULL}};
		GType geary_imap_data_format_quoting_type_id;
		geary_imap_data_format_quoting_type_id = g_enum_register_static ("GearyImapDataFormatQuoting", values);
		g_once_init_leave (&geary_imap_data_format_quoting_type_id__volatile, geary_imap_data_format_quoting_type_id);
	}
	return geary_imap_data_format_quoting_type_id__volatile;
}

static gboolean
_vala_char_array_contains (gchar * stack,
                           int stack_length,
                           const gchar needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

gboolean
geary_imap_data_format_is_special_char (gchar ch,
                                        gchar* ar,
                                        gint ar_length1,
                                        const gchar* exceptions)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (((gint) ch) <= 0x1F) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = ((gint) ch) >= 0x7F;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	if (_vala_char_array_contains (ar, ar_length1, ch)) {
		gboolean _tmp1_ = FALSE;
		if (exceptions != NULL) {
			_tmp1_ = geary_ascii_index_of (exceptions, ch) < 0;
		} else {
			_tmp1_ = TRUE;
		}
		result = _tmp1_;
		return result;
	}
	result = FALSE;
	return result;
}

/**
 * Returns true if the character is considered an atom special.  Note that while documentation
 * indicates that the backslash cannot be used in an atom, they *are* used for message flags and
 * thus must be special cased by the caller.
 */
inline gboolean
geary_imap_data_format_is_atom_special (gchar ch,
                                        const gchar* exceptions)
{
	gboolean result = FALSE;
	result = geary_imap_data_format_is_special_char (ch, GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS, (gint) G_N_ELEMENTS (GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS), exceptions);
	return result;
}

/**
 * Tag specials are like atom specials but include the continuation character ('+').  Also, the
 * star character is allowed, although technically only correct in the context of a status response;
 * it's the responsibility of the caller to catch this.
 */
gboolean
geary_imap_data_format_is_tag_special (gchar ch,
                                       const gchar* exceptions)
{
	gboolean result = FALSE;
	result = geary_imap_data_format_is_special_char (ch, GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS, (gint) G_N_ELEMENTS (GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS), exceptions);
	return result;
}

/**
 * Returns Quoting to indicate if the string must be quoted before sent on the wire, of if it
 * must be sent as a literal.
 */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

GearyImapDataFormatQuoting
geary_imap_data_format_is_quoting_required (const gchar* str)
{
	GearyImapDataFormatQuoting result = 0;
	gint index = 0;
	g_return_val_if_fail (str != NULL, 0);
	if (geary_string_is_empty (str)) {
		result = GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED;
		return result;
	}
	index = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gchar ch = '\0';
			gint _tmp1_;
			if (!_tmp0_) {
			}
			_tmp0_ = FALSE;
			_tmp1_ = index;
			index = _tmp1_ + 1;
			ch = string_get (str, (glong) _tmp1_);
			if (ch == GEARY_STRING_EOS) {
				break;
			}
			if (((gint) ch) > 0x7F) {
				result = GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED;
				return result;
			}
			switch (ch) {
				case '\n':
				case '\r':
				{
					result = GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED;
					return result;
				}
				default:
				{
					if (geary_imap_data_format_is_atom_special (ch, NULL)) {
						result = GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED;
						return result;
					}
					break;
				}
			}
		}
	}
	result = GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL;
	return result;
}

