/* rfc822.c generated by valac 0.44.7, the Vala compiler
 * generated from rfc822.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gmime/gmime.h>

typedef enum  {
	GEARY_RF_C822_TEXT_FORMAT_PLAIN,
	GEARY_RF_C822_TEXT_FORMAT_HTML
} GearyRFC822TextFormat;

#define GEARY_RF_C822_TYPE_TEXT_FORMAT (geary_rf_c822_text_format_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

extern gint geary_rf_c822_init_count;
gint geary_rf_c822_init_count = 0;
extern GRegex* geary_rf_c822_invalid_filename_character_re;
GRegex* geary_rf_c822_invalid_filename_character_re = NULL;

GType geary_rf_c822_text_format_get_type (void) G_GNUC_CONST;
#define GEARY_RF_C822_UTF8_CHARSET "UTF-8"
#define GEARY_RF_C822_ASCII_CHARSET "US-ASCII"
void geary_rf_c822_init (void);
gboolean geary_rf_c822_is_utf_8 (const gchar* charset);

/**
 * Common text formats supported by {@link Geary.RFC822}.
 */
GType
geary_rf_c822_text_format_get_type (void)
{
	static volatile gsize geary_rf_c822_text_format_type_id__volatile = 0;
	if (g_once_init_enter (&geary_rf_c822_text_format_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_RF_C822_TEXT_FORMAT_PLAIN, "GEARY_RF_C822_TEXT_FORMAT_PLAIN", "plain"}, {GEARY_RF_C822_TEXT_FORMAT_HTML, "GEARY_RF_C822_TEXT_FORMAT_HTML", "html"}, {0, NULL, NULL}};
		GType geary_rf_c822_text_format_type_id;
		geary_rf_c822_text_format_type_id = g_enum_register_static ("GearyRFC822TextFormat", values);
		g_once_init_leave (&geary_rf_c822_text_format_type_id__volatile, geary_rf_c822_text_format_type_id);
	}
	return geary_rf_c822_text_format_type_id__volatile;
}

void
geary_rf_c822_init (void)
{
	gint _tmp0_;
	static const gchar* USER_CHARSETS[2] = {GEARY_RF_C822_UTF8_CHARSET, NULL};
	GError* _inner_error0_ = NULL;
	_tmp0_ = geary_rf_c822_init_count;
	geary_rf_c822_init_count = _tmp0_ + 1;
	if (_tmp0_ != 0) {
		return;
	}
	g_mime_init ((guint32) GMIME_ENABLE_RFC2047_WORKAROUNDS);
	g_mime_set_user_charsets (USER_CHARSETS);
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
		_tmp2_ = g_regex_new ("[/\\0]", 0, 0, &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch237_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_regex_unref0 (geary_rf_c822_invalid_filename_character_re);
		geary_rf_c822_invalid_filename_character_re = _tmp3_;
		_g_regex_unref0 (_tmp1_);
	}
	goto __finally237;
	__catch237_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally237:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

gboolean
geary_rf_c822_is_utf_8 (const gchar* charset)
{
	gboolean result = FALSE;
	gchar* up = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	g_return_val_if_fail (charset != NULL, FALSE);
	_tmp0_ = g_utf8_strup (charset, (gssize) -1);
	up = _tmp0_;
	_tmp6_ = up;
	if (g_strcmp0 (_tmp6_, "ASCII") == 0) {
		_tmp5_ = TRUE;
	} else {
		const gchar* _tmp7_;
		_tmp7_ = up;
		_tmp5_ = g_strcmp0 (_tmp7_, "US-ASCII") == 0;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp8_;
		_tmp8_ = up;
		_tmp4_ = g_strcmp0 (_tmp8_, "US_ASCII") == 0;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp9_;
		_tmp9_ = up;
		_tmp3_ = g_strcmp0 (_tmp9_, "UTF-8") == 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp10_;
		_tmp10_ = up;
		_tmp2_ = g_strcmp0 (_tmp10_, "UTF8") == 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp11_;
		_tmp11_ = up;
		_tmp1_ = g_strcmp0 (_tmp11_, "UTF_8") == 0;
	}
	result = _tmp1_;
	_g_free0 (up);
	return result;
}

